/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.morphing;

import java.awt.*;
import javax.swing.*;
import javax.swing.GroupLayout;
import com.frojasg1.applications.common.components.internationalization.window.InternationalizationInitializationEndCallback;
import com.frojasg1.applications.common.configuration.application.BaseApplicationConfigurationInterface;
import com.frojasg1.general.desktop.view.license.GenericLicenseJDialog;
import java.util.function.Consumer;
import javax.swing.JDialog;
import javax.swing.JFrame;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class LicenseJDialog extends GenericLicenseJDialog 
{
	protected static final String _configurationBaseFileName = "LicenseJDialog";
	public static final String BASE_RTF_FILE_NAME = "Application.License.rtf";

	/**
	 * Creates new form LicenseJDialog
	 */
	public LicenseJDialog( JFrame parent, BaseApplicationConfigurationInterface appConf,
							Consumer<InternationalizationInitializationEndCallback> initializationEndCallBack,
							boolean hasToAcceptLicense )
	{
		super( parent, appConf, initializationEndCallBack,
			BASE_RTF_FILE_NAME, hasToAcceptLicense,
			_configurationBaseFileName);
//		initComponents();

		setRtfDocument();
	}

	public LicenseJDialog( JFrame parent, BaseApplicationConfigurationInterface appConf,
							Consumer<InternationalizationInitializationEndCallback> initializationEndCallBack
						)
	{
		this( parent, appConf, initializationEndCallBack, true );
	}

	/**
	 * Creates new form LicenseJDialog
	 */
	public LicenseJDialog( JDialog parent, BaseApplicationConfigurationInterface appConf,
							Consumer<InternationalizationInitializationEndCallback> initializationEndCallBack,
							boolean hasToAcceptLicense )
	{
		super( parent, appConf, initializationEndCallBack,
			BASE_RTF_FILE_NAME, hasToAcceptLicense,
			_configurationBaseFileName);
//		initComponents();

		setRtfDocument();
	}

	public LicenseJDialog( JDialog parent, BaseApplicationConfigurationInterface appConf,
							Consumer<InternationalizationInitializationEndCallback> initializationEndCallBack
						)
	{
		this(parent, appConf, initializationEndCallBack, true);
	}

	/**
	 * This method is called from within the constructor to initialize the form.
	 * WARNING: Do NOT modify this code. The content of this method is always
	 * regenerated by the Form Editor.
	 */
	@SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    // Generated using JFormDesigner non-commercial license
    private void initComponents() {

        //======== this ========
        setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        Container contentPane = getContentPane();

        GroupLayout contentPaneLayout = new GroupLayout(contentPane);
        contentPane.setLayout(contentPaneLayout);
        contentPaneLayout.setHorizontalGroup(
            contentPaneLayout.createParallelGroup()
                .addGap(0, 400, Short.MAX_VALUE)
        );
        contentPaneLayout.setVerticalGroup(
            contentPaneLayout.createParallelGroup()
                .addGap(0, 300, Short.MAX_VALUE)
        );
        pack();
        setLocationRelativeTo(getOwner());
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    // Generated using JFormDesigner non-commercial license
    // End of variables declaration//GEN-END:variables
}
