/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.morphing.context;

import com.frojasg1.applications.libmorphing.contexts.MorphingEditorApplicationContext;
import com.frojasg1.applications.libmorphing.contexts.MorphingEditorApplicationContextBase;
import com.frojasg1.applications.morphing.configuration.ApplicationConfiguration;
import com.frojasg1.applications.morphing.mvc.MorphingController;
import com.frojasg1.applications.morphing.mvc.MorphingView;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ApplicationContextImp
		extends MorphingEditorApplicationContextBase
	implements MorphingEditorApplicationContext
{
	protected MorphingController _controller;
	protected MorphingView _view;

	public ApplicationContextImp()
	{
	}

	@Override
	public ApplicationContextImp init() {
		super.init();
		return this;
	}

	@Override
	public ApplicationConfiguration getAppliConf()
	{
		return( ApplicationConfiguration.instance() );
	}

	public MorphingController getController() {
		return _controller;
	}

	public void setController(MorphingController _controller) {
		this._controller = _controller;
	}

	public MorphingView getView() {
		return _view;
	}

	public void setView(MorphingView _view) {
		this._view = _view;
	}
}
