/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.morphing.imagelisttable.evt;

import com.frojasg1.general.view.evt.wrapper.impl.MultiMapForBuildingJComponentWrapperEvents;
import com.frojasg1.general.view.evt.wrapper.impl.table.impl.GenTableWrapperEventBuilderBase;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class MorphingTableEventBuilder<RR, TT>
	extends GenTableWrapperEventBuilderBase<RR, TT>
{

	public MorphingTableEventBuilder(TT table, Class<RR> recordClass) {
		super(table, recordClass, true);
	}

	protected MorphingTableEventBuilder(TT table, Class<RR> recordClass, boolean withInit) {
		super(table, recordClass, false);

		if( withInit )
			init();
	}

	@Override
	protected void fillMultiMap(MultiMapForBuildingJComponentWrapperEvents multiMap) {
		super.fillMultiMap(multiMap);

        multiMap.put( JTableWrapperRecordsClonedEvent.EVENT_TYPE, JTableWrapperRecordsClonedEvent.class, JTableWrapperRecordsClonedEvent::new );
	}

}
