/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.morphing.language;

import com.frojasg1.general.language.LanguageResources;
import com.frojasg1.applications.morphing.configuration.ApplicationConfiguration;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class MorphingApplicationLanguageResources extends LanguageResources
{
	protected static MorphingApplicationLanguageResources _instance;

	public static MorphingApplicationLanguageResources instance()
	{
		if( _instance == null )
		{
			_instance = new MorphingApplicationLanguageResources();
			LanguageResources.instance().addLanguageResource(_instance);
		}
		return( _instance );
	}

	public void copyOwnLanguageConfigurationFilesFromJar( String newFolder )
	{
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "AboutText.rtf" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "Application.License.rtf" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "JDial_about_LAN.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "JDial_applicationConfiguration_LAN.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "LicenseJFrame_LAN.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "MainWindow_LAN.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "Splash_LAN.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "LicenseJDialog_LAN.properties" );
//		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "StringsConfiguration.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", MorphingApplicationInternationalTexts.GLOBAL_CONF_FILE_NAME );
	}

	protected String getPropertiesPathInJar()
	{
		return( ApplicationConfiguration.sa_PROPERTIES_PATH_IN_JAR );
	}
}
