/* 
 * Copyright (C) 2022 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/gpl-3.0.txt
 *
 */

package com.frojasg1.applications.morphing.videobuilder.configuration;

import com.frojasg1.applications.common.configuration.application.BaseApplicationConfigurationFactory;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ApplicationConfigurationFactory implements BaseApplicationConfigurationFactory<ApplicationConfiguration> {

	@Override
	public ApplicationConfiguration create(String applicationName) {
		ApplicationConfiguration result = ApplicationConfiguration.create( applicationName );
		return( result );
	}

	@Override
	public ApplicationConfiguration create(String mainFolder, String applicationName, String version, String group, String globalConfFileName)
	{
		ApplicationConfiguration result = new ApplicationConfiguration( mainFolder, applicationName, version, group, globalConfFileName );
		return( result );
	}
}
