/* 
 * Copyright (C) 2022 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/gpl-3.0.txt
 *
 */

package com.frojasg1.applications.morphing.videobuilder.context;

import com.frojasg1.applications.libmorphing.contexts.MorphingEditorApplicationContextBase;
import com.frojasg1.applications.morphing.videobuilder.configuration.ApplicationConfiguration;
import com.frojasg1.delaunay.triangulation.quadedge.builder.QuadEdgeDelaunayBuilder;


/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ApplicationContextImp extends MorphingEditorApplicationContextBase
{
	protected QuadEdgeDelaunayBuilder _quadEdgeDelaunayBuilder;

	public ApplicationContextImp()
	{
	}

	@Override
	public ApplicationContextImp init() {
		super.init();
		return this;
	}

	@Override
	public ApplicationConfiguration getAppliConf()
	{
		return( ApplicationConfiguration.instance() );
	}

	public QuadEdgeDelaunayBuilder getDelaunayBuilder() {
		return _quadEdgeDelaunayBuilder;
	}

	public void setDelaunayBuilder(QuadEdgeDelaunayBuilder _quadEdgeDelaunayBuilder) {
		this._quadEdgeDelaunayBuilder = _quadEdgeDelaunayBuilder;
	}
}
