/* 
 * Copyright (C) 2022 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/gpl-3.0.txt
 *
 */

package com.frojasg1.applications.morphing.videobuilder.language;

import com.frojasg1.applications.morphing.videobuilder.configuration.ApplicationConfiguration;
import com.frojasg1.general.language.LanguageResources;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class VideoBuilderLanResources extends LanguageResources
{
	protected static VideoBuilderLanResources _instance;

	public static VideoBuilderLanResources instance()
	{
		if( _instance == null )
		{
			_instance = new VideoBuilderLanResources();
			LanguageResources.instance().addLanguageResource(_instance);
		}
		return( _instance );
	}

	public void copyOwnLanguageConfigurationFilesFromJar( String newFolder )
	{
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "AboutText.rtf" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "Application.License.rtf" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "JDial_about_LAN.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "LicenseJFrame_LAN.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "MainWindow_LAN.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "Splash_LAN.properties" );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", "LicenseJDialog_LAN.properties" );
	}

	protected String getPropertiesPathInJar()
	{
		return( ApplicationConfiguration.sa_PROPERTIES_PATH_IN_JAR );
	}
}
