/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.delaunay.triangulation.quadedge;

import com.frojasg1.general.arrays.impl.ResizableArrayImpl;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
// http://karlchenofhell.org/cppswp/lischinski.pdf
public class EdgeArray extends ResizableArrayImpl<Edge>
{
	public EdgeArray()
	{
		super( 4, 4 );
	}

	@Override
	public int add(Edge elem) {
		int index = super.add(elem);
		elem.setNum(index);
		elem.setArray(this);

		return( index );
	}

	@Override
	protected Edge[] createArray(int numElems) {
		return( new Edge[numElems] );
	}

	@Override
	protected EdgeArray createEmptyCopy() {
		return( new EdgeArray() );
	}

	@Override
	public EdgeArray copyState()
	{
		return( (EdgeArray) super.copyState() );
	}
}
