/*
 * Copyright (c) 2023. Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3.0 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */

package com.frojasg1.delaunay.triangulation.quadedge.builder.impl;

import com.frojasg1.delaunay.triangulation.quadedge.DelaunaySubdivision;
import com.frojasg1.libgeometry.types.GeometricRectangle;
import com.frojasg1.libgeometry.types.Point2d;
import org.junit.Before;
import org.junit.Test;

public class QuadEdgeDelaunayBuilderImplTest {

    protected QuadEdgeDelaunayBuilderImpl instance;

    @Before
    public void setUp() throws Exception {
        instance = new QuadEdgeDelaunayBuilderImpl();
    }


    @Test
    public void createDelaunaySubdivisionTriangle() {

        GeometricRectangle bounds = new GeometricRectangle(0, 0, 10, 10);
        Point2d a = instance.createPoint(0, 0);
        Point2d b = instance.createPoint(0, 10);
        Point2d c = instance.createPoint(10, 0);

        DelaunaySubdivision delaunaySubdivision = new DelaunaySubdivision(bounds, instance,
                a, b, c);
    }

    @Test
    public void createDelaunaySubdivisionRectangle() {

        GeometricRectangle bounds = new GeometricRectangle(0, 0, 10, 10);

        DelaunaySubdivision delaunaySubdivision = new DelaunaySubdivision(bounds, instance);
    }
}