/*
 * Copyright (c) 2023. Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3.0 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */

package com.frojasg1.applications.libmorphing.api.facedetector.mesh;

public class Landmark68Mesh {

    // 68_landmark_points_mesh.png
    public static final int[][] TRIANGLES = {
//            {20, 21, 23},
//            {21, 22, 23},
            {0, 1, 36},
            {1, 36, 41},
            {1, 2, 41},
            {2, 41, 31},
            {2, 3, 31},
            {3, 31, 48},
            {3, 4, 48},
            {4, 5, 48},
            {5, 6, 48},
            {6, 48, 59},
            {6, 7, 59},
            {7, 58, 59},
            {7, 8, 58},
            {8, 57, 58},
            {8, 56, 57},
            {8, 9, 56},
            {9, 55, 56},
            {9, 10, 55},
            {10, 54, 55},
            {10, 11, 54},
            {11, 12, 54},
            {12, 13, 54},
            {13, 35, 54},
            {13, 14, 35},
            {14, 35, 46},
            {14, 15, 46},
            {15, 45, 46},
            {15, 16, 45},
            {16, 26, 45},
            {26, 25, 45},
            {25, 44, 45},
            {24, 25, 44},
            {24, 43, 44},
            {23, 24, 43},
            {23, 42, 43},
            {22, 23, 42},
            {22, 27, 42},
            {21, 22, 27},
            {21, 27, 39},
            {20, 21, 39},
            {20, 38, 39},
            {19, 20, 38},
            {19, 37, 38},
            {18, 19, 37},
            {18, 36, 37},
            {17, 18, 36},
            {0, 17, 36},
            {36, 37, 41},
            {37, 41, 40},
            {37, 38, 40},
            {38, 39, 40},
            {41, 40, 31},
            {40, 31, 29},
            {40, 39, 29},
            {39, 28, 29},
            {39, 27, 28},
            {27, 28, 42},
            {28, 29, 42},
            {29, 42, 47},
            {29, 35, 47},
            {47, 46, 35},
            {42, 43, 47},
            {43, 44, 47},
            {44, 47, 46},
            {44, 46, 45},
            {29, 30, 31},
            {30, 31, 32},
            {30, 32, 33},
            {30, 33, 34},
            {30, 34, 35},
            {29, 30, 35},
            {31, 48, 49},
            {31, 49, 50},
            {31, 32, 50},
            {32, 50, 51},
            {32, 33, 51},
            {33, 34, 51},
            {34, 51, 52},
            {34, 35, 52},
            {35, 52, 53},
            {35, 53, 54},
            {48, 49, 60},
            {49, 60, 61},
            {49, 50, 61},
            {50, 61, 62},
            {50, 51, 62},
            {51, 52, 62},
            {52, 62, 63},
            {52, 53, 63},
            {53, 63, 64},
            {53, 64, 54},
            {54, 64, 55},
            {64, 55, 65},
            {55, 56, 65},
            {65, 66, 56},
            {56, 66, 57},
            {57, 66, 58},
            {66, 67, 58},
            {67, 59, 58},
            {59, 60, 67},
            {48, 59, 60},
            {60, 51, 67},
            {61, 67, 66},
            {61, 62, 66},
            {62, 63, 66},
            {66, 65, 63},
            {63, 64, 65}
            };
}
