/*
 * Copyright (c) 2023. Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3.0 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */

package com.frojasg1.applications.libmorphing.api.facedetector.pojo;

import com.frojasg1.applications.libmorphing.model.images.vertex.map.impl.control.IndexedVerticesMap;
import com.frojasg1.libgeometry.types.Point2d;

public class FaceDetectionMeshData {

    protected FaceDetection originalFaceDetection;
    protected FaceDetectionFrame faceDetectionFrame;
    protected IndexedVerticesMap landmark80points;
    protected int[][] triangles;
    protected String name;

    protected FaceDetection modifiedFaceDetection;

    public FaceDetection getOriginalFaceDetection() {
        return originalFaceDetection;
    }

    public void setOriginalFaceDetection(FaceDetection originalFaceDetection) {
        this.originalFaceDetection = originalFaceDetection;
    }

    public FaceDetectionFrame getFaceDetectionFrame() {
        return faceDetectionFrame;
    }

    public void setFaceDetectionFrame(FaceDetectionFrame faceDetectionFrame) {
        this.faceDetectionFrame = faceDetectionFrame;
    }

    public IndexedVerticesMap getLandmark80points() {
        return landmark80points;
    }

    public void setLandmark80points(IndexedVerticesMap landmark80points) {
        this.landmark80points = landmark80points;
    }

    public int[][] getTriangles() {
        return triangles;
    }

    public void setTriangles(int[][] triangles) {
        this.triangles = triangles;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public FaceDetection getModifiedFaceDetection() {
        return modifiedFaceDetection;
    }

    public void setModifiedFaceDetection(FaceDetection modifiedFaceDetection) {
        this.modifiedFaceDetection = modifiedFaceDetection;
    }

    public void resetModifiedFaceDetection() {
        modifiedFaceDetection = getOriginalFaceDetection().createCopy();
    }

    public void setModifiedPoint(int index, Point2d pt) {
        getModifiedFaceDetection().setPoint(index, pt);
    }
}
