/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.libmorphing.language;

import com.frojasg1.applications.libmorphing.view.DelaunayTriangulationViewerWindowBase;
import com.frojasg1.general.language.LanguageResources;


/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class LibMorphingLanguageResources extends LanguageResources
{
	public static final String sa_PROPERTIES_PATH_IN_JAR = "com/frojasg1/applications/libmorphing/inter";

	
	protected static LibMorphingLanguageResources _instance;

	public static LibMorphingLanguageResources instance()
	{
		if( _instance == null )
		{
			_instance = new LibMorphingLanguageResources();
			LanguageResources.instance().addLanguageResource(_instance);
		}
		return( _instance );
	}

	@Override
	public void copyOwnLanguageConfigurationFilesFromJar( String newFolder )
	{
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", LibMorphingInternationalTexts.GLOBAL_CONF_FILE_NAME );
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", DelaunayTriangulationViewerWindowBase.sa_configurationBaseFileName );
	}

	protected String getPropertiesPathInJar()
	{
		return( sa_PROPERTIES_PATH_IN_JAR );
	}
}
