/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.libmorphing.model.images.transitions;

import com.frojasg1.general.map.multimap.MultiMap;
import com.frojasg1.general.map.multimap.MultiMapMapEntry;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
@Deprecated
public class TransitionConfigurationModelMap extends MultiMap<TransitionConfigurationModel>
{
	public static final String MAIN_MAP = "MAIN_MAP";

	public TransitionConfigurationModelMap()
	{
		this( true );
	}

	protected TransitionConfigurationModelMap( boolean init )
	{
		if( init )
			init();
	}

	@Override
	protected Map<String, MultiMapMapEntry<?, TransitionConfigurationModel>> fillMultiMapMapEntryMap() {
		Map<String, MultiMapMapEntry<?, TransitionConfigurationModel>> result = new HashMap<>();

		addMultiMapMapEntry( result, MAIN_MAP, TransitionConfigurationModelKey.class,
							TransitionConfigurationModel::getKey );

		return( result );
	}

	public TransitionConfigurationModelKey createKey( String fromImageName, String toImageName )
	{ 
		TransitionConfigurationModelKey key = new TransitionConfigurationModelKey();
		key.setFromImageName(fromImageName);
		key.setToImageName(toImageName);

		return( key );
	}

	public TransitionConfigurationModel get( String fromImageName, String toImageName )
	{
		TransitionConfigurationModelKey key = createKey( fromImageName, toImageName );

		return( get( MAIN_MAP, key ) );
	}
}
