/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.libmorphing.model.images.vertex.map;

import com.frojasg1.applications.libmorphing.model.images.vertex.VertexModel;
import com.frojasg1.general.map.multimap.dynamic.deductible.DeductibleDynamicMultiMapMapEntryContext;
import java.util.function.UnaryOperator;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class MorphingVerticesMapMapEntryContext extends DeductibleDynamicMultiMapMapEntryContext<VertexModel>
{
	protected UnaryOperator<VertexModel> _fromMasterDirectTranslator;

	public MorphingVerticesMapMapEntryContext(String name) {
		super(name);
	}

	public UnaryOperator<VertexModel> getFromMasterDirectTranslator() {
		return _fromMasterDirectTranslator;
	}

	public void setFromMasterDirectTranslator(UnaryOperator<VertexModel> _fromMasterDirectTranslator) {
		this._fromMasterDirectTranslator = _fromMasterDirectTranslator;
	}
}
