/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.libmorphing.model.images.video;

import com.frojasg1.applications.libmorphing.model.images.configuration.MorphingProjectConfigurationModel;
import com.frojasg1.libgeometry.types.Size2d;
import com.frojasg1.general.xml.model.NameKeyWithFileNameModelBase;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class MorphingVideoConfigurationModel extends NameKeyWithFileNameModelBase
{
	protected String _formatName;
	protected Size2d _resolution;
	protected MorphingProjectConfigurationModel _morphingConfiguration;

	public MorphingVideoConfigurationModel(String name) {
		super(name);
	}

	public String getFormatName() {
		return _formatName;
	}

	public void setFormatName(String _formatName) {
		this._formatName = _formatName;
	}

	public Size2d getResolution() {
		return _resolution;
	}

	public void setResolution(Size2d _resolution) {
		this._resolution = _resolution;
	}

	public MorphingProjectConfigurationModel getMorphingConfiguration() {
		return _morphingConfiguration;
	}

	public void setMorphingConfiguration(MorphingProjectConfigurationModel _morphingConfiguration) {
		this._morphingConfiguration = _morphingConfiguration;
	}
}
