/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.libmorphing.view.panels.evt;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class DelaunayPanelsEventTypes {
	public static final long NAVIGATOR_EVT = 0x100;
	public static final long ZOOM_EVT = 0x200;
	public static final long NEW_BOUNDARY_BUTTON_PRESSED_EVT = 0x400;
	public static final long FADED_MASTER_IMAGE_BUTTON_PRESSED_EVT = 0x800;
	public static final long MAKE_MASTER_IMAGE_EVT = 0x1000;
	public static final long CHANGE_TRANSITION_EVT = 0x2000;

	public static final long VERTEX_EVT = 0x10000;
	public static final long CLEAR_TRIANGULATION_EVT = 0x20000;
	public static final long NEW_ON_THE_FLY_BOUNDS_EVT = 0x40000;
	public static final long NEW_CONFIRMED_BOUNDS_EVT = 0x80000;
	public static final long TRIANGLE_SELECTED_EVT = 0x100000;
	public static final long FACE_DETECTION_SELECTED_EVT = 0x200000;

	public static final long LAYER_SELECTION_EVT = 0x400000;
	public static final long RUN_FACE_DETECTION_EVT = 0x800000;

	public static final long RECALCULATE_TRIANGULATION_EVT = 0x1000000;

	public static final long RESET_MODIFIED_DETECTED_FACE_MESH_EVT = 0x2000000;

	public static final long RESET_DETECTED_FACE_MESH_FRAME_EVT = 0x4000000;
	public static final long INSERT_68_DETECTED_POINTS_EVT = 0x8000000;
}
