/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.applications.libmorphing.view.panels.evt;

import com.frojasg1.applications.libmorphing.view.panels.evt.enums.VertexEventType;
import com.frojasg1.libgeometry.types.Point2d;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class VertexEventData extends ImageNameEventDataBase
{
	protected Point2d _originalVertex;
	protected Point2d _vertex;
	protected boolean _isConfirmed;
	protected VertexEventType _type;


	public Point2d getVertex() {
		return _vertex;
	}

	public void setVertex(Point2d _vertex) {
		this._vertex = _vertex;
	}

	public boolean isConfirmed() {
		return _isConfirmed;
	}

	public void setIsConfirmed(boolean _isConfirmed) {
		this._isConfirmed = _isConfirmed;
	}

	public VertexEventType getType() {
		return _type;
	}

	public void setType(VertexEventType _type) {
		this._type = _type;
	}

	public Point2d getOriginalVertex() {
		return _originalVertex;
	}

	public void setOriginalVertex(Point2d _originalVertex) {
		this._originalVertex = _originalVertex;
	}

	@Override
	public String toString() {
		return "VertexEventData{" + "_imageName=" + imageName + ", _originalVertex=" + _originalVertex + ", _vertex=" + _vertex + ", _isConfirmed=" + _isConfirmed + ", _type=" + _type + '}';
	}
}
