/*
 * Copyright (c) 2023. Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3.0 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */

package com.frojasg1.applications.libmorphing.xml.whole;

import com.frojasg1.applications.libmorphing.model.images.color.ColorsMap;
import com.frojasg1.applications.libmorphing.model.images.configuration.MorphingProjectConfigurationModel;
import com.frojasg1.applications.libmorphing.model.images.image.MorphingImageModel;
import com.frojasg1.applications.libmorphing.model.images.image.MorphingImageModelList;
import com.frojasg1.applications.libmorphing.model.images.transitions.TransitionConfigurationModelMap;
import com.frojasg1.applications.libmorphing.model.images.video.MorphingVideoConfigurationModelMapWrapper;
import com.frojasg1.applications.libmorphing.xml.facedetector.FaceDetectionWholeFileModel;
import com.frojasg1.general.xml.model.KeyModel;
import com.frojasg1.general.xml.model.NameKeyModel;
import com.frojasg1.general.xml.model.NameKeyWithFileNameModel;

public interface MorphingProjectWholeFileModel extends KeyModel<String>, NameKeyModel, NameKeyWithFileNameModel {
    void init();

    ColorsMap getColorsMap();

    MorphingProjectConfigurationModel getDefaultConfiguration();

    TransitionConfigurationModelMap getTransitionConfigurationMap();

    MorphingVideoConfigurationModelMapWrapper getVideoConfigurationMap();

    MorphingImageModelList getImagesListWrapper();

    MorphingImageModel getMasterImageModel();

    MorphingImageModel getImageModel(String imageName);

    String getMasterImageName();

    String getDirName();

    public FaceDetectionWholeFileModel getFaceDetectionForXml();

    public void setFaceDetectionForXml(FaceDetectionWholeFileModel faceDetectionForXml);

//    public ImageFaceDetectionPersistenceModelMap getImageFaceDetectionPersistenceModelMap();
//
//    public void setImageFaceDetectionPersistenceModelMap(ImageFaceDetectionPersistenceModelMap imageFaceDetectionPersistenceModelMap);
}
