package com.frojasg1.weka.clustering.factory;

import com.frojasg1.libgenai.clustering.model.ClustererModel;
import com.frojasg1.libgenai.clustering.model.ClustererTrainer;
import com.frojasg1.libgenai.clustering.model.ClustererTypeContext;
import com.frojasg1.libgenai.clustering.model.impl.gaussianmixture.GaussianMixtureConfiguration;
import com.frojasg1.weka.clustering.model.gaussianmixture.io.WekaGaussianMixtureValues;
import weka.clusterers.EM;

public interface LibWekaFactory {
    public ClustererModel<GaussianMixtureConfiguration> createModel(EM expectationMaximization,
                                                                    GaussianMixtureConfiguration configuration);

    public ClustererModel<GaussianMixtureConfiguration> createModel(WekaGaussianMixtureValues wekaGaussianMixtureValues);

    public ClustererTrainer<GaussianMixtureConfiguration> createTrainer(GaussianMixtureConfiguration configuration);

    public WekaGaussianMixtureValues createWekaGaussianMixtureValues(ClustererModel<GaussianMixtureConfiguration> model);

    public ClustererTypeContext<GaussianMixtureConfiguration> createContext();

    public GaussianMixtureConfiguration createConfiguration();
}
