package com.frojasg1.libgenai.clustering.model.impl.gaussianmixture;

import com.frojasg1.libgenai.clustering.model.ClustererConfigurationBase;
import com.frojasg1.libgenai.clustering.model.type.ClusteringAlgorithmEnum;
import java.util.Arrays;

public class GaussianMixtureConfigurationBase
        extends ClustererConfigurationBase
        implements GaussianMixtureConfiguration {

    protected int seed;
    protected int numClusters;
    protected double minValueForSelectingCluster;
    protected String[] attributeNames;
    protected Integer maxIterations;

    public GaussianMixtureConfigurationBase() {
        super(ClusteringAlgorithmEnum.GAUSSIAN_MIXTURE);
    }

    @Override
    public int getSeed() {
        return seed;
    }

    @Override
    public void setSeed(int seed) {
        this.seed = seed;
    }

    @Override
    public int getNumClusters() {
        return numClusters;
    }

    @Override
    public void setNumClusters(int numClusters) {
        this.numClusters = numClusters;
    }

    @Override
    public double getMinValueForSelectingCluster() {
        return minValueForSelectingCluster;
    }

    @Override
    public void setMinValueForSelectingCluster(double minValueForSelectingCluster) {
        this.minValueForSelectingCluster = minValueForSelectingCluster;
    }

    @Override
    public String[] getAttributeNames() {
        return attributeNames;
    }

    @Override
    public void setAttributeNames(String... attributeNames) {
        this.attributeNames = attributeNames;
    }

    @Override
    public Integer getMaxIterations() {
        return maxIterations;
    }

    @Override
    public void setMaxIterations(Integer maxIterations) {
        this.maxIterations = maxIterations;
    }

    @Override
    public String toString() {
        return "GaussianMixtureConfigurationBase{" +
                "algorithm=" + algorithm +
                ", modelName='" + modelName + '\'' +
                ", seed=" + seed +
                ", numClusters=" + numClusters +
                ", minValueForSelectingCluster=" + minValueForSelectingCluster +
                ", attributeNames=" + Arrays.toString(attributeNames) +
                ", maxIterations=" + maxIterations +
                '}';
    }
}
