package com.frojasg1.libgenai.clustering.model.impl.gaussianmixture;

import com.frojasg1.general.ArrayFunctions;
import com.frojasg1.libgenai.clustering.model.ClustererModel;
import com.frojasg1.libgenai.metrics.OneDMetrics;

public abstract class GaussianMixtureModelBase
        implements ClustererModel<GaussianMixtureConfiguration> {

    protected GaussianMixtureConfiguration configuration;

    @Override
    public void setConfiguration(GaussianMixtureConfiguration configuration) {
        this.configuration = configuration;
    }

    @Override
    public GaussianMixtureConfiguration getConfiguration() {
        return configuration;
    }

    @Override
    public Integer getCluster(double[] instance) {
        Integer result = null;
        double[] probabilities = getClusterProbabilities(instance);
        double max = getOneDMetrics().max(probabilities);
        result = getArrayFunctions().getIndex(probabilities, max);

        if(result < getConfiguration().getMinValueForSelectingCluster()) {
            result = null;
        }

        return result;
    }

    protected ArrayFunctions getArrayFunctions() {
        return ArrayFunctions.instance();
    }

    protected OneDMetrics getOneDMetrics() {
        return OneDMetrics.instance();
    }


    @Override
    public int getNumClusters() {
        return getConfiguration().getNumClusters();
    }
}
