package com.frojasg1.libgenai.clustering.model.impl.gaussianmixture.io;

import com.frojasg1.general.xml.XmlElement;
import com.frojasg1.general.xml.persistency.loader.impl.ModelToXmlBase;
import com.frojasg1.libgenai.clustering.model.impl.gaussianmixture.GaussianMixtureConfiguration;

public class GaussianMixtureConfigurationToXml
    extends ModelToXmlBase<GaussianMixtureConfiguration> {

    @Override
    public XmlElement build(GaussianMixtureConfiguration config) {
        XmlElement result = createElement("configuration");

        createLeafElementGen(result, "numClusters", config.getNumClusters());
        createLeafElementGen(result, "seed", config.getSeed());
        createLeafElementGen(result, "minValueForSelectingCluster", config.getMinValueForSelectingCluster());
        fillAttributeNames(createElement(result, "attributeNames"), config);

        return result;
    }

    protected void fillAttributeNames(XmlElement xeResult, GaussianMixtureConfiguration config) {
        for(String attributeName: config.getAttributeNames()) {
            createLeafElement(xeResult, "attributeName", attributeName);
        }
    }
}
