package com.frojasg1.libgenai.clustering.model.impl.gaussianmixture.io;

import com.frojasg1.general.xml.XmlElement;
import com.frojasg1.general.xml.persistency.loader.impl.XmlToModelBase;
import com.frojasg1.libgenai.clustering.model.impl.gaussianmixture.GaussianMixtureConfiguration;
import com.frojasg1.libgenai.clustering.model.impl.gaussianmixture.GaussianMixtureConfigurationBase;
import java.util.stream.Collectors;

public class XmlToGaussianMixtureConfiguration
    extends XmlToModelBase<GaussianMixtureConfiguration> {


    @Override
    public GaussianMixtureConfiguration build(XmlElement xmlElement) {
        GaussianMixtureConfiguration result = new GaussianMixtureConfigurationBase();

        result.setNumClusters(getMandatoryChildInt(xmlElement, "numClusters"));
        result.setSeed(getMandatoryChildInt(xmlElement, "seed"));
        result.setMinValueForSelectingCluster(getMandatoryChildDouble(xmlElement, "minValueForSelectingCluster"));
        result.setAttributeNames(getAttributeNames(getMandatoryChild(xmlElement, "attributeNames")));

        return result;
    }

    protected String[] getAttributeNames(XmlElement xe) {
        return xe.getChildrenByName("attributeName")
                .getCollection().stream()
                .map(XmlElement::getText)
                .collect(Collectors.toList())
                .toArray( new String[0]);
    }
}
