package com.frojasg1.libgenai.clustering.model.type;

import com.frojasg1.libgenai.clustering.model.ClustererConfiguration;
import com.frojasg1.libgenai.clustering.model.impl.gaussianmixture.GaussianMixtureConfiguration;

public enum ClusteringAlgorithmEnum implements ClusteringAlgorithm {
    K_MEANS(ClustererConfiguration.class),
    K_MEANS_PLUS_PLUS(ClustererConfiguration.class),
    K_MEDOIDS(ClustererConfiguration.class),
    K_MEDOIDS_PLUS_PLUS(ClustererConfiguration.class),
    GAUSSIAN_MIXTURE(GaussianMixtureConfiguration.class);

    private Class<? extends ClustererConfiguration> configurationClass;

    ClusteringAlgorithmEnum(Class<? extends ClustererConfiguration> configurationClass) {
        this.configurationClass = configurationClass;
    }

    @Override
    public String getName() {
        return name();
    }

    @Override
    public Class<? extends ClustererConfiguration> getConfigurationClass() {
        return configurationClass;
    }


}
