/*
 * Copyright (c) 2023. Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3.0 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */

package com.frojasg1.applications.common.configuration.application.impl;

import com.frojasg1.applications.common.configuration.application.BaseApplicationConfiguration;
import com.frojasg1.general.number.DoubleReference;

import java.io.File;

public class DummyApplicationConfiguration extends BaseApplicationConfiguration {

    protected static final String DEFAULT_LANGUAGE = "EN";

    protected String propertiesPathInJar;

    protected String mainFolder;
    protected String applicationName;
    protected String group;

    public DummyApplicationConfiguration(String mainFolder, String applicationName, String group, String language,
                                         String configurationFileName, String propertiesPathInJar) {
        super(mainFolder, applicationName, group, language, configurationFileName);
        this.mainFolder = mainFolder;
        this.applicationName = applicationName;
        this.group = group;
        this.propertiesPathInJar = propertiesPathInJar;
    }

    @Override
    public String getConfigurationMainFolder()
    {
        return( mainFolder );
    }

    @Override
    public String getApplicationName()
    {
        return( applicationName );
    }

    @Override
    public String getApplicationGroup()
    {
        return( group );
    }

    @Override
    public String getInternationalPropertiesPathInJar()
    {
        return( propertiesPathInJar );
//		return( null );
    }

    @Override
    public String getApplicationNameFolder() {
        return null;
    }

    @Override
    public String getAdditionalLanguage() {
        return null;
    }

    @Override
    public void setAdditionalLanguage(String language) {

    }

    @Override
    public boolean getLicensesHaveBeenAccepted() {
        return false;
    }

    @Override
    public void setLicensesHaveBeenAccepted(boolean value) {

    }

    @Override
    public String getDefaultLanguageBaseConfigurationFolder()
    {
        String result = System.getProperty("user.home") + File.separator  +
                getConfigurationMainFolder() + File.separator +
                getApplicationNameFolder() + File.separator +
                getApplicationGroup() + File.separator;

        return( result );
    }

    @Override
    public String getDefaultLanguageConfigurationFolder(String language)
    {
        String result = getDefaultLanguageBaseConfigurationFolder() + File.separator +
                language;

        return( result );
    }

    @Override
    public String getDefaultLanguage() {
        return null;
    }

    @Override
    public String getApplicationVersion() {
        return null;
    }

    @Override
    public String getResourceNameForApplicationIcon() {
        return null;
    }

    @Override
    public void setZoomFactorReference(DoubleReference zoomFactor) {

    }

    @Override
    public DoubleReference getZoomFactorReference() {
        return null;
    }
}
