/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.collection.functions;

import com.frojasg1.general.CollectionFunctions;
import java.util.List;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ListStateContextBase<RR> {
	protected Integer _selectedIndex;
	protected List<RR> _list;
	protected int[] _selection;

	public RR getSelectedItem()
	{
		return( CollectionFunctions.instance().get(_list, _selectedIndex) );
	}

	public Integer getSelectedIndex() {
		return _selectedIndex;
	}

	public void setSelectedIndex(Integer _selectedIndex) {
		this._selectedIndex = _selectedIndex;
	}

	public List<RR> getList() {
		return _list;
	}

	public void setList(List<RR> _list) {
		this._list = _list;
	}

	public int[] getSelection() {
		return _selection;
	}

	public void setSelection(int[] _selection) {
		this._selection = _selection;
	}
}
