/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.copy;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class CopyFacilitiesFunctions {
	protected static CopyFacilitiesFunctions INSTANCE = new CopyFacilitiesFunctions();

	public static CopyFacilitiesFunctions instance()
	{
		return( INSTANCE );
	}

	public <C extends CopyFacilities<C>> C copy( C obj, C that )
	{
		C result = null;

		if( obj == that )
			result = that;
		else if( that != null )
		{
			if( obj != null )
			{
				result = obj;
				obj.copy(that);
			}
			else
				result = that.createCopy();
		}

		return( result );
	}
}
