/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.dialogs;

import com.frojasg1.general.dialogs.filefilter.GenericFileFilter;
import com.frojasg1.general.dialogs.filefilter.impl.GenericFileFilterIsAnyExtension;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Supplier;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class DialogsWrapperFunctions
{
	protected static class LazyHolder
	{
		public static final DialogsWrapperFunctions INSTANCE = new DialogsWrapperFunctions();
	}

	public static DialogsWrapperFunctions instance()
	{
		return LazyHolder.INSTANCE;
	}

	public GenericFileFilterIsAnyExtension createExtensionFilter( String description, String ... extensions )
	{
		return( createExtensionFilter( () -> description, extensions ) );
	}

	public GenericFileFilterIsAnyExtension createExtensionFilter( Supplier<String> descriptionFunction,
																String ... extensions )
	{
		return( new GenericFileFilterIsAnyExtension( descriptionFunction, extensions ) );
	}
/*
	public List<GenericFileFilter> createListOfFilters( String ... texts )
	{
		if( (texts.length) % 2 != 0 )
			throw( new IllegalArgumentException( "Error, texts length was not an even number" ) );

		List<GenericFileFilter> result = new ArrayList<>();
		for( int ii=0; ii<texts.length; ii += 2)
		{
			String description = texts[ii];
			String extension = texts[ii+1];
			result.add( createExtensionFilter(description, extension) );
		}

		return( result );
	}
*/
}
