/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.dialogs.filefilter.impl.executable;

import com.frojasg1.general.dialogs.filefilter.impl.GenericFileFilterBase;
import com.frojasg1.general.dialogs.filefilter.impl.helpers.GenericFileChooserHelper;
import java.util.Random;
import java.util.function.Supplier;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class GenericFileFilterForExecutable extends GenericFileFilterBase//implements GenericFileFilter
{
	protected static final int RANDOM_HASH = new Random().nextInt();

	public GenericFileFilterForExecutable( Supplier<String> descriptionSupplier )
	{
		super( GenericFileChooserHelper.instance()::isExecutable, descriptionSupplier );
	}
/*
	protected static final String CONF_DESCRIPTION = GenericFileFilterChooserImpl.CONF_GENERIC_FILE_FILTER_FOR_EXECUTABLE_BY_ATTRIBUTES_DESCRIPTION;
	protected InternationalizedStringConf _internationalStrings = null;

	public GenericFileFilterForExecutable( InternationalizedStringConf internationalStrings )
	{
		_internationalStrings = internationalStrings;
	}

	@Override
	public boolean accept(File file)
	{
		return( file.canRead() && file.canExecute() );
	}

	@Override
	public String getDescription()
	{
		return( _internationalStrings.getInternationalString(CONF_DESCRIPTION) );
	}
*/
	@Override
	public int hashCode()
	{
		return( RANDOM_HASH );
	}

	@Override
	public boolean equals( Object that )
	{
		if (this == that)
			return true;

		boolean result = false;
		if( that != null )
			result = that.getClass().equals( getClass() );

		return( result );
	}
}
