/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.dialogstoshow.imp;

import com.frojasg1.general.dialogstoshow.GenericDialogToShowInt;
import com.frojasg1.general.view.ViewComponent;
import com.frojasg1.general.zoom.ZoomInterface;
import com.frojasg1.generic.GenericFunctions;
import java.awt.Color;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ColorChooserDialogToShow extends GenericDialogToShowBase
{
	protected String _title = null;
	protected Color defaultColor;

	public ColorChooserDialogToShow(ViewComponent parent, String title, Color defaultColor)
	{
		super( parent );

		_title = title;
		this.defaultColor = defaultColor;
	}

	public void setTitle( String title )
	{
		_title = title;
	}

	@Override
	public Result showDialog()
	{
		Color chosenColor = GenericFunctions.instance().getDialogsWrapper().showColorChooserDialog(_parent, _title, defaultColor );

		Result result = new Result(chosenColor);

		return( result );
	}

	public static class Result implements GenericDialogToShowInt.Result
	{
		protected Color chosenColor;

		public Result( Color chosenColor )
		{
			this.chosenColor = chosenColor;
		}

		public Color getChosenColor()
		{
			return( chosenColor );
		}
	}
}
