/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.executor;

import java.util.concurrent.atomic.AtomicBoolean;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class StopableExecutorBase implements StopableExecutor {
	protected boolean _hasToStop;
	protected AtomicBoolean _hasToCancel;

	protected boolean getHasToStop()
	{
		return( _hasToStop || ( _hasToCancel != null ) && ( _hasToCancel.get() ) );
	}

	@Override
	public boolean isHasToStop() {
		return( getHasToStop() );
	}

	@Override
	public void setHasToStop(boolean _hasToStop) {
		this._hasToStop = _hasToStop;
	}

	@Override
	public AtomicBoolean getHasToCancelRef() {
		return _hasToCancel;
	}

	@Override
	public void setHasToCancelRef(AtomicBoolean _hasToCancel) {
		this._hasToCancel = _hasToCancel;
	}
}
