/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.geom.impl;

import com.frojasg1.general.copyable.DefaultConstructorInitCopier;
import com.frojasg1.general.geom.GenSize;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class GenSizeImpl implements GenSize {
	protected int _width;
	protected int _height;

	public GenSizeImpl()
	{}

	public GenSizeImpl( int width, int height )
	{
		_width = width;
		_height = height;
	}

	public void GenSizeImpl( GenSizeImpl that )
	{
		_width = that._width;
		_height = that._height;
	}

	@Override
	public int getWidth() {
		return _width;
	}

	@Override
	public void setWidth(int _width) {
		this._width = _width;
	}

	@Override
	public int getHeight() {
		return _height;
	}

	@Override
	public void setHeight(int _height) {
		this._height = _height;
	}
}
