/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.io;

import com.frojasg1.general.io.model.GenericIOModelContextBase;
import com.frojasg1.general.collection.ModifiedStatus;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */

/*
	MMO - Model for output (to be writen to disk, it can accept more general types, to be able to translate)
	MMI - Model for input (it is the most particular, as it reads from disk exactly the type expected)
*/
public class DefaultGenericIO<MM extends ModifiedStatus>
	extends GenericIOBase<MM, GenericIOModelContextBase<MM>>
{

	public DefaultGenericIO( LinesAndModelTranslator<MM, MM> linesModelTranslator )
	{
		super( linesModelTranslator );
	}

	@Override
	public GenericIOModelContextBase<MM> createEmptyModelContext() {
		return( new GenericIOModelContextBase<MM>() );
	}
}
