/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.io.model.list;

import com.frojasg1.general.io.*;
import com.frojasg1.general.io.model.GenericIOModelContext;
import java.io.IOException;
import java.io.OutputStream;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */

/*
	MMO - Model for output (to be writen to disk, it can accept more general types, to be able to translate)
	MCO - Model Context for output
	MMI - Model for input (it is the most particular, as it reads from disk exactly the type expected)
	MCI - Model Context for input
*/
public interface LinesIOListModelGenericOutputIO<RRO> {

	public void write( GenericIOModelContext<? extends IOListModelBase<? extends RRO>> modelContext, String fileName ) throws IOException;
	public boolean erase( String fileName );

	public void write( GenericIOModelContext<? extends IOListModelBase<? extends RRO>> modelContext, OutputStream os ) throws IOException;
}
