/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.io.model.list;

import com.frojasg1.general.io.LinesToModelTranslator;
import java.util.List;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */

/*
	RRO - Record for output ( it is more generic than RRI. To make it possible translation between Record implementations)
	RRI - Record for input ( it is derived from RRO. It is more particular, as we read exactly the type of file that produces the expected Record implementation type)
	MMI - Model for input (it is a list of Records of type RRI)
*/
public interface LinesIOListModelTranslator<RRO,
											RRI extends RRO, MMI extends IOListModelBase<RRI>>
	extends LinesToModelTranslator<MMI>
{

	public List<String> modelToLines( IOListModelBase<? extends RRO> model );
}
