/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.listeners.event;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 * @param <SS>	- Source
 * @param <ED>	- EventData
 */
public class GenericEventBase<ET, SS, ED> implements GenericEvent<ET, SS, ED> {
	protected ET _eventType;
	protected SS _source;
	protected ED _data;

	@Override
	public SS getSource() {
		return _source;
	}

	public void setSource(SS _source) {
		this._source = _source;
	}

	@Override
	public ED getEventData() {
		return _data;
	}

	public void setEventData(ED _data) {
		this._data = _data;
	}

	@Override
	public ET getEventType() {
		return( _eventType );
	}

	public void setEventType( ET eventType )
	{
		_eventType = eventType;
	}
}
