/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.listeners.event.factory;

import com.frojasg1.general.listeners.event.GenericEvent;
import com.frojasg1.general.listeners.event.GenericEventBase;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class GenericEventFactoryBase
{
	public <ET, SS, ED> GenericEvent<ET, SS, ED> createGenericEvent( ET eventType,
																	SS source,
																	ED eventData )
	{
		GenericEventBase<ET, SS, ED> result = new GenericEventBase<>();
		result.setSource(source);
		result.setEventData(eventData);
		result.setEventType(eventType);

		return( result );
	}
}
