/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.map.multimap;

import java.util.Map;
import java.util.function.Function;
import org.slf4j.LoggerFactory;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public abstract class MultiMap<VV> extends MultiMapGen<VV, MultiMapMapEntry<?, VV>> {
    private static final org.slf4j.Logger LOGGER = LoggerFactory.getLogger(MultiMap.class);

    protected Map<String, MultiMapMapEntry<?, VV>> mapByName;

	public MultiMap()
	{
		this(false);
	}

	public MultiMap(boolean init)
	{
		if( init )
			init();
	}

	protected <K> MultiMapMapEntry<?, VV> createEmptyMultiMapMapEntry(Class<K> keyClass,
												Function<VV, K> keyGetter)
	{
		return( new MultiMapMapEntry<>( keyClass, keyGetter ) );
	}

    protected abstract Map<String, MultiMapMapEntry<?, VV>> fillMultiMapMapEntryMap();

}
