/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.map.multimap.dynamic.deductible;

import com.frojasg1.general.xml.model.NameKeyModelBase;
import java.util.function.UnaryOperator;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 * @param <EV>	- Element Value
 */
public abstract class DeductibleDynamicMultiMapMapEntryContext<EV> extends NameKeyModelBase
{
	protected UnaryOperator<EV> _fromMasterTranslator;
	protected UnaryOperator<EV> _toMasterTranslator;

	public DeductibleDynamicMultiMapMapEntryContext( String name )
	{
		super( name );
	}

	public UnaryOperator<EV> getFromMasterTranslator() {
		return _fromMasterTranslator;
	}

	public void setFromMasterTranslator(UnaryOperator<EV> _fromMasterTranslator) {
		this._fromMasterTranslator = _fromMasterTranslator;
	}

	public UnaryOperator<EV> getToMasterTranslator() {
		return _toMasterTranslator;
	}

	public void setToMasterTranslator(UnaryOperator<EV> _toMasterTranslator) {
		this._toMasterTranslator = _toMasterTranslator;
	}
}
