/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.structures;

import java.util.Objects;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class Pair<KK, VV>
{
	protected KK _key = null;
	protected VV _value = null;

	public Pair( KK key, VV value )
	{
		_key = key;
		_value = value;
	}

	public KK getKey()
	{
		return( _key );
	}

	public VV getValue()
	{
		return( _value );
	}

	public void setKey( KK key )
	{
		_key = key;
	}

	public void setValue( VV value )
	{
		_value = value;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o) {
			return true;
		}
		if (o == null || getClass() != o.getClass()) {
			return false;
		}
		Pair<?, ?> pair = (Pair<?, ?>) o;
		return Objects.equals(_key, pair._key) && Objects.equals(_value, pair._value);
	}

	@Override
	public int hashCode() {
		return Objects.hash(_key, _value);
	}
}
