/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.time;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class TimeFunctions {
	protected static TimeFunctions _instance = new TimeFunctions();
	
	public static TimeFunctions instance()
	{
		return( _instance );
	}

	public String getTimeStr(int ms)
	{
		int hh = ms / 3600000;
		int mm = ( ms / 60000 ) % 60;
		int ss = ( ms / 1000 ) % 60;

		return( String.format( "%d:%02d:%02d", hh, mm, ss ) );
	}
}
