/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.view.evt.wrapper.impl;

import java.util.function.Supplier;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class GenComponentWrapperEventBuildingContext<EVT> {
	protected Long _eventType;
	protected Class<EVT> _eventClass;
	protected Supplier<EVT> _constructor;

	public Long getEventType() {
		return _eventType;
	}

	public void setEventType(Long _eventType) {
		this._eventType = _eventType;
	}

	public Class<EVT> getEventClass() {
		return _eventClass;
	}

	public void setEventClass(Class<EVT> _eventClass) {
		this._eventClass = _eventClass;
	}

	public Supplier<EVT> getConstructor() {
		return _constructor;
	}

	public void setConstructor(Supplier<EVT> _constructor) {
		this._constructor = _constructor;
	}
}
