/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.view.evt.wrapper.impl.combobox.impl;

import com.frojasg1.general.view.evt.wrapper.impl.combobox.GenComboBoxWrapperEventBase;
import com.frojasg1.general.view.evt.wrapper.impl.combobox.GenComboBoxWrapperEventType;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ComboBoxWrapperNewItemSelectedEvt<CB, RR>
	extends GenComboBoxWrapperEventBase<RR, CB, ComboBoxWrapperNewItemSelectedEvtData>
{
	public static final long EVENT_TYPE = GenComboBoxWrapperEventType.NEW_ITEM_SELECTED;

	protected RR _newItemSelected;

	public ComboBoxWrapperNewItemSelectedEvt()
	{
		super( EVENT_TYPE );
	}

	public RR getNewItemSelected() {
		return _newItemSelected;
	}

	public void setNewItemSelected(RR value) {
		_newItemSelected = value;
	}
}
