/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.view.evt.wrapper.impl.table.impl;

import com.frojasg1.general.collection.functions.ListStateContextBase;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 * @param <RR>	- Record of model
 * @param <CC>	- ListStateContext derived class
 */
public class GenTableWrapperRecordsModifiedEventBaseData<RR, CC extends ListStateContextBase<RR>>
{
	protected CC _previous;
	protected CC _after;

	public CC getPrevious() {
		return _previous;
	}

	public void setPrevious(CC _previous) {
		this._previous = _previous;
	}

	public CC getAfter() {
		return _after;
	}

	public void setAfter(CC _after) {
		this._after = _after;
	}
}
