/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.desktop.liblens.graphics;

import java.util.Objects;

/**
 *
 * @author Usuario
 */
public class Coordinate2D implements Comparable
{
	public int x = -1;
	public int y = -1;

	public Coordinate2D() {
		this(0, 0);
	}

	public Coordinate2D(int xx, int yy )
	{
		x = xx;
		y = yy;
	}
	
	public Coordinate2D( Coordinate2D other )
	{
		x = other.M_getX();
		y = other.M_getY();
	}

	public void copy( Coordinate2D other )
	{
		x = other.x;
		y = other.y;
	}

	public int M_getX()	{	return(x);	}
	public int M_getY()	{	return(y);	}

	public void M_setX( int xx )		{	x = xx; }
	public void M_setY( int yy )		{	y = yy; }

	@Override
	public boolean equals(Object o) {
		if (this == o) return true;
		if (o == null || getClass() != o.getClass()) return false;
		Coordinate2D that = (Coordinate2D) o;
		return x == that.x && y == that.y;
	}

	@Override
	public int hashCode() {
		return Objects.hash(x, y);
	}

	@Override
	public int compareTo( Object obj )
	{
		int result = -1;

		if( obj instanceof Coordinate2D )
		{
			Coordinate2D other = (Coordinate2D) obj;
			result = x - other.M_getX();
			
			if( result == 0 )
				result = y - other.M_getY();
		}

		return( result );
	}

	@Override
	public String toString()
	{
		return( String.format( "( %d, %d )", x, y) );
	}
}
