/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.desktop.liblens.graphics;

import java.awt.*;

public class LibLensGraphicsHelper {

    protected static LibLensGraphicsHelper instance = new LibLensGraphicsHelper();

    public static LibLensGraphicsHelper instance() {
        return instance;
    }

    public boolean contains(Rectangle rect, Coordinate2D pt) {
        return (pt.x >= rect.x) && (pt.x < rect.x + rect.width) &&
                (pt.y >= rect.y) && (pt.y < rect.y + rect.height);
    }
}
