/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.edt;

import com.frojasg1.general.ExecutionFunctions;
import java.util.concurrent.Semaphore;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ParallelExecutionResult<RR>
{
	protected volatile RR _result;
	protected Semaphore _semaphore = new Semaphore(0);

	public RR getResult() {
		return _result;
	}

	public void setResult(RR _result) {
		this._result = _result;
	}

	public Semaphore getSemaphore() {
		return _semaphore;
	}

	public void setSemaphore(Semaphore _semaphore) {
		this._semaphore = _semaphore;
	}

	public void semaphoreAcquire()
	{
		ExecutionFunctions.instance().safeMethodExecution( () -> _semaphore.acquire(1) );		
	}
}
