/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.generic.application;

import com.frojasg1.general.desktop.application.version.DesktopApplicationVersion;
import com.frojasg1.generic.application.ApplicationFacilitiesBase;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class DesktopApplicationFacilities extends ApplicationFacilitiesBase
{
	protected static DesktopApplicationFacilities _instance = null;

	public static DesktopApplicationFacilities instance()
	{
		if( _instance == null )
			_instance = new DesktopApplicationFacilities();

		return( _instance );
	}

	@Override
	public String getApplicationVersion()
	{
		return( DesktopApplicationVersion.instance().getDownloadFile() );
	}
}
