/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.generic.files;

import com.frojasg1.general.files.BinaryFile;
import com.frojasg1.general.files.GenericFileFacilities;

/**
 *
 * @author Usuario
 */
public class DesktopFileFacilities implements GenericFileFacilities
{
	protected static DesktopFileFacilities _instance = null;
	
	public static DesktopFileFacilities instance()
	{
		if( _instance == null )
			_instance = new DesktopFileFacilities();
		
		return( _instance );
	}
	
	protected DesktopFileFacilities()
	{}
	
	@Override
	public BinaryFile createBinaryFile()
	{
		return( new DesktopBinaryFile() );
	}
}
