/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.startapp;

import com.frojasg1.applications.common.configuration.application.BaseApplicationConfigurationInterface;
import com.frojasg1.general.context.ApplicationContext;
import com.frojasg1.general.desktop.view.color.ColorInversor;
import com.frojasg1.general.lib3d.components.api.about.animation.AnimationForAboutFactory;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public interface GenericDesktopInitContext extends ApplicationContext {
	public void setApplicationName( String value );
	public String getApplicationName();
	public void setAnimationForAboutFactory( AnimationForAboutFactory animationFactory );
	public AnimationForAboutFactory getAnimationForAboutFactory();
	public void setColorInversor(ColorInversor ci);
	public ColorInversor getColorInversor();

	public BaseApplicationConfigurationInterface getAppliConf();
	public void setAppliConf( BaseApplicationConfigurationInterface appliConf );
}
