/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.associatedcomponents;

import com.frojasg1.general.listeners.filterevents.EventListenerContextBase;
import com.frojasg1.general.listeners.filterevents.ListOfDefaultEventContextListenersBase;
import java.util.function.Consumer;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 * @param <EV>	- Event
 */
public class ComponentEvtWrapperListenersContextBase<EV extends ComponentEvtEvent>
			extends ListOfDefaultEventContextListenersBase<EV, Long>
{
	public ComponentEvtWrapperListenersContextBase()
	{
		super( lon -> 1L, ev -> 1L );
	}

	@Override
	protected EventListenerContextBase<EV, Long> createListenerContext( Consumer<? super EV> consumer,
																	Long ... eventTypesToRegister )
	{
		return( createListenerContextInternal( consumer, -1L ) );
	}
}
