/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.associatedcomponents.evt;

import com.frojasg1.general.desktop.view.associatedcomponents.ComponentEvtEvent;
import com.frojasg1.general.desktop.view.associatedcomponents.ComponentEvtEventBase;
import com.frojasg1.general.desktop.view.associatedcomponents.ComponentEvtWrapperSimpleBase;
import java.awt.Component;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public abstract class ComponentEvtWrapperSimpleDefaultBase<CC extends Component>
	extends ComponentEvtWrapperSimpleBase<CC, ComponentEvtEvent>
{
	public ComponentEvtWrapperSimpleDefaultBase(CC component, Component parent) {
		super(component, parent);
	}

	@Override
	protected ComponentEvtEvent createEmptyEvent()
	{
		return( new ComponentEvtEventBase() );
	}
}
