/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.associatedcomponents.evt.impl;

import com.frojasg1.general.desktop.view.associatedcomponents.evt.ComponentEvtWrapperSimpleDefaultBase;
import java.awt.Component;
import java.awt.event.ActionListener;
import javax.swing.JMenuItem;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class MenuItemEvtWrapper extends ComponentEvtWrapperSimpleDefaultBase<JMenuItem> {

	protected ActionListener _componentListener;

	public MenuItemEvtWrapper(JMenuItem component, Component parent) {
		super(component, parent);
	}

	@Override
	protected void initChild()
	{
		_componentListener = createComponentListener();

		super.initChild();
	}

	protected ActionListener createComponentListener()
	{
		return( evt -> internalValueChangedListener() );
	}

	public ActionListener getComponentListener() {
		return _componentListener;
	}

	@Override
	protected void addListener()
	{
		getComponent().addActionListener( getComponentListener() );
	}

	@Override
	protected void removeListeners()
	{
		getComponent().removeActionListener( getComponentListener() );
	}
}
