/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.associatedcomponents.value;

import com.frojasg1.general.desktop.view.associatedcomponents.ComponentEvtEventBase;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ValueChangedEventBase<VV>
	extends ComponentEvtEventBase
	implements ValueChangedEvent<VV>
{
	protected VV _previousValue;
	protected VV _newValue;

	@Override
	public VV getPreviousValue() {
		return _previousValue;
	}

	@Override
	public void setPreviousValue(VV _previousValue) {
		this._previousValue = _previousValue;
	}

	@Override
	public VV getNewValue() {
		return _newValue;
	}

	@Override
	public void setNewValue(VV _newValue) {
		this._newValue = _newValue;
	}
}
