
/*
 * Copyright (c) 2023. Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3.0 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */

package com.frojasg1.general.desktop.view.associatedcomponents.value.builder;

import com.frojasg1.general.desktop.view.associatedcomponents.value.impl.bool.AssociatedComponentBooleanValueUpdaterDefault;
import com.frojasg1.general.desktop.view.associatedcomponents.value.impl.integer.AssociatedComponentIntValueUpdaterDefault;
import java.awt.Component;

/**
 *
 * @author fjavier.rojas
 */
public class AssociatedComponentValueWrapperBuilder
{
	protected static AssociatedComponentValueWrapperBuilder INSTANCE = new AssociatedComponentValueWrapperBuilder();

	public static AssociatedComponentValueWrapperBuilder instance()
	{
		return( INSTANCE );
	}

	public AssociatedComponentIntValueUpdaterDefault createAssociatedIntComponentWrapper( Integer initialValue,
																						Integer minValue,
																						Integer maxValue,
																						Component parent,
																						Component ... components )
	{
		AssociatedComponentIntValueUpdaterDefault result = new AssociatedComponentIntValueUpdaterDefault(initialValue, minValue, maxValue);
		result.init();

		for( Component comp: components )
			result.addComponentToWrap(comp, parent);

		return( result );
	}

	public AssociatedComponentBooleanValueUpdaterDefault createAssociatedIntComponentWrapper( Boolean initialValue,
																						Component parent,
																						Component ... components )
	{
		AssociatedComponentBooleanValueUpdaterDefault result = new AssociatedComponentBooleanValueUpdaterDefault(initialValue);
		result.init();

		for( Component comp: components )
			result.addComponentToWrap(comp, parent);

		return( result );
	}
}
