/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.associatedcomponents.value.impl;

import com.frojasg1.general.desktop.view.associatedcomponents.value.AssociatedComponentValueUpdaterBase;
import com.frojasg1.general.desktop.view.associatedcomponents.value.ComponentValueWrapper;
import com.frojasg1.general.desktop.view.associatedcomponents.value.ValueChangedEvent;
import com.frojasg1.general.desktop.view.associatedcomponents.value.ValueChangedEventBase;
import com.frojasg1.general.functional.interfaces.TriFunction;
import java.awt.Component;
import java.util.function.BiFunction;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class AssociatedComponentValueUpdaterDefault<VV,
				WW extends ComponentValueWrapper<VV, ValueChangedEvent<VV>>>
	extends AssociatedComponentValueUpdaterBase<VV, ValueChangedEvent<VV>, WW>
{
/*
	public AssociatedComponentValueUpdaterDefault(
		Class<VV> classForWrapperBuilder,
		VV initialValue) {
		this( ComponentValueWrapperBuilderBase.instance()::apply, classForWrapperBuilder, initialValue);
	}

	public AssociatedComponentValueUpdaterDefault(
		TriFunction<Class<?>, Component, Component, WW> wrapperBuilderByClass,
		Class<VV> classForWrapperBuilder,
		VV initialValue) {
		this( ( comp, parent ) ->
				wrapperBuilderByClass.apply( classForWrapperBuilder, comp, parent ),
			initialValue);
	}
*/

	public AssociatedComponentValueUpdaterDefault(
		BiFunction<Component, Component, WW> wrapperBuilder,
		VV initialValue) {
		super(wrapperBuilder, initialValue);
	}

	@Override
	protected ValueChangedEvent<VV> createEmptyEvent() {
		return( new ValueChangedEventBase<>() );
	}
}
