/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.associatedcomponents.value.impl.bool;

import com.frojasg1.general.desktop.view.associatedcomponents.value.impl.*;
import com.frojasg1.general.desktop.view.associatedcomponents.value.ComponentValueWrapperSimpleDefault;
import java.awt.Component;
import java.util.Map;
import java.util.function.BiFunction;
import javax.swing.JCheckBox;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JToggleButton;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ComponentBoolValueWrapperBuilder
	extends ComponentValueWrapperBuilderBase<Boolean>
{
	protected static final ComponentBoolValueWrapperBuilder INSTANCE = new ComponentBoolValueWrapperBuilder().init();

	public static ComponentBoolValueWrapperBuilder instance()
	{
		return( INSTANCE );
	}

	public ComponentBoolValueWrapperBuilder init()
	{
		super.init();

		return( this );
	}

	protected void fillMap( Map<Class<? extends Component>,
				BiFunction<Component, Component,
						ComponentValueWrapperSimpleDefault>> map )
	{
		put( map, JCheckBoxMenuItem.class, JCheckBoxMenuItemWrapperDefault::new );
		put( map, JCheckBox.class, JCheckBoxWrapperDefault::new );
		put( map, JToggleButton.class, ToggleButtonWrapperDefault::new );
	}

	public ComponentValueWrapperSimpleDefault<? extends Component, Boolean> apply(Component component,
																				Component parent)
	{
		return( super.apply(component, parent) );
	}
}
