/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.associatedcomponents.value.impl.bool;

import com.frojasg1.general.desktop.view.associatedcomponents.value.ComponentValueWrapperSimpleDefault;
import java.awt.Component;
import java.awt.event.ActionListener;
import javax.swing.JCheckBoxMenuItem;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class JCheckBoxMenuItemWrapperDefault extends ComponentValueWrapperSimpleDefault<JCheckBoxMenuItem, Boolean>
{

	protected ActionListener _componentListener;

	public JCheckBoxMenuItemWrapperDefault(JCheckBoxMenuItem component, Component parent ) {
		super(component, parent);
	}

	@Override
	protected void initChild()
	{
		_componentListener = createComponentListener();

		super.initChild();
	}

	protected ActionListener createComponentListener()
	{
		return( evt -> internalValueChangedListener() );
	}

	public ActionListener getComponentListener() {
		return _componentListener;
	}

	@Override
	protected void addListener() {
		getComponent().addActionListener( getComponentListener() );
	}

	@Override
	protected void removeListeners() {
		getComponent().removeActionListener( getComponentListener() );
	}

	@Override
	public Boolean getValue() {
		return( getComponent().isSelected() );
	}

	@Override
	public void setValue(Boolean value) {
		getComponent().setSelected(value);
	}
}
