/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.associatedcomponents.value.impl.integer;

import com.frojasg1.general.desktop.view.associatedcomponents.value.BoundedComponentValueWrapperSimpleDefault;
import com.frojasg1.general.desktop.view.associatedcomponents.value.impl.*;
import java.awt.Component;
import java.util.Map;
import java.util.function.BiFunction;
import javax.swing.JSlider;
import javax.swing.JSpinner;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ComponentIntValueWrapperBuilder
	extends BoundedComponentValueWrapperBuilderBase<Integer>
{
	protected static final ComponentIntValueWrapperBuilder INSTANCE = new ComponentIntValueWrapperBuilder().init();

	public static ComponentIntValueWrapperBuilder instance()
	{
		return( INSTANCE );
	}

	public ComponentIntValueWrapperBuilder init()
	{
		super.init();

		return( this );
	}

	protected void fillMap( Map<Class<? extends Component>,
				BiFunction<Component, Component,
						BoundedComponentValueWrapperSimpleDefault>> map )
	{
		put( map, JSlider.class, JSliderWrapperDefault::new );
		put( map, JSpinner.class, JSpinnerWrapperDefault::new );
	}

	public BoundedComponentValueWrapperSimpleDefault<? extends Component, Integer> apply(Component component,
																				Component parent)
	{
		return( super.apply(component, parent) );
	}
}
