/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.color.impl;

import com.frojasg1.general.desktop.view.color.ColorInversor;
import com.frojasg1.general.desktop.view.color.ColorThemeChangeableStatus;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ColorThemeChangeableBase implements ColorThemeChangeableStatus
{
	protected boolean _isDarkMode = false;
	protected boolean _wasLatestModeDark = false;
	protected boolean _doNotInvertColors = false;

	@Override
	public boolean isDarkMode()
	{
		return( _isDarkMode );
	}

	@Override
	public void setDarkMode(boolean value, ColorInversor colorInversor)
	{
		_isDarkMode = value;
	}

	@Override
	public boolean wasLatestModeDark()
	{
		return( _wasLatestModeDark );
	}

	@Override
	public void setLatestWasDark(boolean value) {
		_wasLatestModeDark = value;
	}

	public boolean hasToChangeColor()
	{
		return( _wasLatestModeDark != _isDarkMode );
	}

	@Override
	public boolean doNotInvertColors() {
		return _doNotInvertColors;
	}

	@Override
	public void setDoNotInvertColors(boolean _doNotInvertColors) {
		this._doNotInvertColors = _doNotInvertColors;
	}
}
