/*
 * Copyright (c) 2023. Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3.0 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */

package com.frojasg1.general.desktop.view.componentwrapper;

import com.frojasg1.general.desktop.view.transfer.file.FileTransferHandler;
import com.frojasg1.general.desktop.view.zoom.mapper.ComponentMapper;
import com.frojasg1.general.desktop.view.zoom.mapper.InternallyMappedComponent;
import com.frojasg1.general.update.Updateable;
import com.frojasg1.general.view.ReleaseResourcesable;
import com.frojasg1.general.view.evt.wrapper.impl.GenComponentWrapperEvent;
import com.frojasg1.general.view.gencomponentwrapper.GenComponentWrapper;

import javax.swing.*;
import javax.swing.plaf.ComponentUI;
import java.awt.*;
import java.util.Locale;

public interface JComponentWrapper<JC extends JComponent, UI extends ComponentUI, EV extends GenComponentWrapperEvent, CC>
        extends GenComponentWrapper<JC, EV>, ReleaseResourcesable, Updateable, InternallyMappedComponent {
    JC getJComponent();

    UI getCompUI();

    FileTransferHandler getFileTransferHandler();

    @Override
    void releaseResources();

    JScrollPane getScrollPane(Component component);

    Locale getOutputLocale();

    @Override
    void setComponentMapper(ComponentMapper mapper);

    @Override
    boolean hasBeenAlreadyMapped();

    void updateInternal();

    @Override
    void update();
}
