/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.panels.volume;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ChangeVolumeEvent {
	protected int _volumeIndB;
	protected boolean _isMuted;

	public float getFactor()
	{
		float result = 1.0f;

		if( isIsMuted() )
			result = 0.0f;
		else
			result = (float) Math.pow( 10, getVolumeIndB() / 20f );

		return( result );
	}

	public int getEffectiveVolumeInDb()
	{
		return( _isMuted ? 0 : _volumeIndB );
	}

	public int getVolumeIndB() {
		return _volumeIndB;
	}

	public ChangeVolumeEvent setVolumeIndB(int _volumeIndB) {
		this._volumeIndB = _volumeIndB;
		return( this );
	}

	public boolean isIsMuted() {
		return _isMuted;
	}

	public ChangeVolumeEvent setIsMuted(boolean _isMuted) {
		this._isMuted = _isMuted;
		return( this );
	}
}
