/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.panels.volume;

import com.frojasg1.applications.common.configuration.imp.InternationalizedStringConfImp;
import com.frojasg1.general.desktop.GenericDesktopConstants;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class VolumePanelInternationalTexts extends InternationalizedStringConfImp {
	public static final String GLOBAL_CONF_FILE_NAME = "VolumePanelInternationalTexts.properties";

	public static final String CONF_MUTE_BUTTON_MUTE_HINT = "jTB_mute.HINT.Mute";
	public static final String CONF_MUTE_BUTTON_ACTIVATE_HINT = "jTB_mute.HINT.Activate";

	protected static class LazyHolder
	{
		protected static final VolumePanelInternationalTexts INSTANCE = new VolumePanelInternationalTexts();
	}

	public static VolumePanelInternationalTexts instance()
	{
		return( LazyHolder.INSTANCE );
	}

	protected VolumePanelInternationalTexts()
	{
		super( GLOBAL_CONF_FILE_NAME, GenericDesktopConstants.sa_PROPERTIES_PATH_IN_JAR );

		registerInternationalizedStrings();
	}

	protected void registerInternationalizedStrings()
	{
		registerInternationalString(CONF_MUTE_BUTTON_MUTE_HINT, "Mute" );
		registerInternationalString(CONF_MUTE_BUTTON_ACTIVATE_HINT, "Activate sound" );
	}
}
