/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.transfer;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public enum DragAndDropEventType {
	ALL(-1, false, false),
	CAN_IMPORT_FIRED( 1, true, false ),
	DROPPED( 2, false, true );

	protected long _longValue;
	protected boolean _isDroppedEvt;
	protected boolean _isCanImportEvt;

	private DragAndDropEventType( long longValue, boolean isCanImportEvt,
									boolean isDroppedEvt )
	{
		_longValue = longValue;
		_isCanImportEvt = isCanImportEvt;
		_isDroppedEvt = isDroppedEvt;
	}

	public boolean isDroppedEvt() {
		return _isDroppedEvt;
	}

	public boolean isCanImportEvt() {
		return _isCanImportEvt;
	}

	public long getLongValue() {
		return _longValue;
	}
}
