/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.transfer.file;

import com.frojasg1.general.desktop.view.transfer.DragAndDropEvent;
import com.frojasg1.general.desktop.view.transfer.DragAndDropEventType;
import java.awt.Component;
import java.awt.Point;
import java.io.File;
import java.util.List;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 * @param <CC>	- Context (depending on the particular component class)
 */
public class FileDragAndDropEvent<CC> extends DragAndDropEvent {
	protected List<File> _fileList;
	protected CC _context;

	public FileDragAndDropEvent( DragAndDropEventType type, Component source,
								Point dropLocation, List<File> fileList )
	{
		super( type, source, dropLocation );
		_fileList = fileList;
	}

	public List<File> getFileList() {
		return _fileList;
	}

	public CC getContext() {
		return _context;
	}

	public void setContext(CC _context) {
		this._context = _context;
	}
}
