/*
 * Copyright (c) 2023. Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3.0 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You may obtain a copy of the License at
 *
 *       http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */

package com.frojasg1.general.desktop.view.zoom.colorchooser.ui;

import com.frojasg1.general.desktop.view.zoom.colorchooser.swatch.ZoomDefaultSwatchChooserPanel;
import java.awt.Color;
import java.util.List;
import javax.swing.JComponent;
import javax.swing.colorchooser.AbstractColorChooserPanel;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.basic.BasicColorChooserUI;

public class ZoomBasicColorChooserUI extends BasicColorChooserUI {

    public static ComponentUI createUI(JComponent c) {
        return new ZoomBasicColorChooserUI();
    }

    protected ZoomDefaultSwatchChooserPanel defaultSwatchChooserPanel;


    protected AbstractColorChooserPanel[] createDefaultChoosers() {
        AbstractColorChooserPanel[] panels = super.createDefaultChoosers();
        defaultSwatchChooserPanel = new ZoomDefaultSwatchChooserPanel();
        panels[0] = defaultSwatchChooserPanel;

        return panels;
    }

    public List<Color> getRecentColors() {
        return defaultSwatchChooserPanel.getRecentColors();
    }

    public void setRecentColors(List<Color> colors) {
        defaultSwatchChooserPanel.setRecentColors(colors);
    }
}
