/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.view.zoom.mapper;

import com.frojasg1.general.collection.impl.ThreadSafeGenListWrapper;
import java.util.List;
import javax.swing.JPopupMenu;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class ContainerOfInternallyMappedComponentBase implements ContainerOfInternallyMappedComponent
{
	protected ThreadSafeGenListWrapper<InternallyMappedComponent> _internallyMappedComponentList = new ThreadSafeGenListWrapper<>();
	protected ThreadSafeGenListWrapper<JPopupMenu> _jPopupMenus = new ThreadSafeGenListWrapper<>();

	public List<InternallyMappedComponent> getInternallyMappedComponentListCopy() {
		return( _internallyMappedComponentList.getListCopy() );
	}

	public List<InternallyMappedComponent> getInternallyMappedComponentList() {
		return _internallyMappedComponentList.getList();
	}

	@Override
	public void addInternallyMappedComponent( InternallyMappedComponent im )
	{
		_internallyMappedComponentList.add(im);
	}

	public List<JPopupMenu> getJPopupMenuListCopy() {
		return( _jPopupMenus.getListCopy() );
	}

	public List<JPopupMenu> getPopupMenuList() {
		return _jPopupMenus.getList();
	}

	@Override
	public void addPopupMenu(JPopupMenu jPopupMenu)
	{
		_jPopupMenus.add(jPopupMenu);
	}
}
