/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.queries.language;


import com.frojasg1.general.desktop.queries.LibInetQueryConstants;
import com.frojasg1.general.language.LanguageResources;

/**
 *
 * @author Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 */
public class LibInetQueryLanguageResources extends LanguageResources
{
	protected static LibInetQueryLanguageResources _instance;

	public static LibInetQueryLanguageResources instance()
	{
		if( _instance == null )
		{
			_instance = new LibInetQueryLanguageResources();
			LanguageResources.instance().addLanguageResource(_instance);
		}
		return( _instance );
	}

	@Override
	public void copyOwnLanguageConfigurationFilesFromJar( String newFolder )
	{
		copyLanguageConfigurationFileFromJarToFolder( newFolder, "EN", LibInetQueryStringsConf.CONF_FILE_NAME );
	}

	protected String getPropertiesPathInJar()
	{
		return( LibInetQueryConstants.sa_PROPERTIES_PATH_IN_JAR );
	}
}
