/* 
 * Copyright (C) 2023 Francisco Javier Rojas Garrido <frojasg1@hotmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3.0 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You may obtain a copy of the License at
 *
 *      http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 */
package com.frojasg1.general.desktop.queries.language;

import com.frojasg1.applications.common.configuration.application.BaseApplicationConfigurationInterface;
import com.frojasg1.applications.common.configuration.imp.InternationalizedStringConfImp;
import com.frojasg1.general.desktop.queries.LibInetQueryConstants;
import com.frojasg1.general.desktop.queries.api.execution.GenericQueryWithResultExecution;
/**
 *
 * @author Usuario
 */
public class LibInetQueryStringsConf extends InternationalizedStringConfImp
{
	public static final String CONF_FILE_NAME = "LibInetQueryStringsConf.properties";

	protected static class LazyHolder
	{
		protected static final LibInetQueryStringsConf INSTANCE = new LibInetQueryStringsConf();
	}

	protected BaseApplicationConfigurationInterface _baseConfiguration = null;

	public static LibInetQueryStringsConf instance()
	{
		return( LazyHolder.INSTANCE );
	}

	protected LibInetQueryStringsConf()
	{
		super( CONF_FILE_NAME, LibInetQueryConstants.sa_PROPERTIES_PATH_IN_JAR );

		registerInternationalStrings();
	}

	protected void registerInternationalStrings()
	{
		registerInternationalString(GenericQueryWithResultExecution.ERROR_EXECUTING_API_QUERY, "Error when executing $1 query: $2. \n Try it again some minutes later. \n If the problem persists, contact the developer at: frojasg1@hotmail.com" );
		registerInternationalString(GenericQueryWithResultExecution.SUCCESS_EXECUTING_API_QUERY, "Successful $1 query execution" );
		registerInternationalString(GenericQueryWithResultExecution.INTERNAL_ERROR, "Internal error" );
		registerInternationalString(GenericQueryWithResultExecution.API_QUERY_RESULT_FOUND_IN_CACHE, "$1 result found in cache" );
	}
}
