#!/bin/bash

function compile_fast() {
    mvn -T 1C clean install -Dmaven.test.skip -DskipTests=true -Dmaven.javadoc.skip=true
}

function compile() {
#    mvn clean package -DskipTests=true
    mvn clean install # -DskipTests=true
}

function format_time() {
    local NUM_SECS_UTC=$(( $1 - 3600 ))
    date +%TZ --date=@$NUM_SECS_UTC | sed -e 's/Z$//'
}

COMPILE=compile
if (( $# == 1 ))
then
    if [[ "$1" == "fast" ]]
    then
        COMPILE=compile_fast
    fi
fi

START=$(date +%s)

#preinstall.sh

$COMPILE

END=$(date +%s)


echo "inicio: $( date -d @$START )"
echo "fin: $( date -d @$END )"

ELAPSED_TIME=$(( END - START ))

echo; echo "tiempo de ejecución: $( format_time $ELAPSED_TIME )"
